<control-location-select>

	<div class="location-select { this.opts.vertical == 'true' ? 'vertical' : '' }">

		<div class="select { !state.search_mode ? 'expanded' : '' }">
			<div class="select-body">
				<div class="column">
					<select class="form-control" data-ref="level0" data-level="0" onchange="{ location_change }">
						<option value="0">{ state.allownone ? 'σε όλους τους νομούς' : 'επιλέξτε νομό' }</option>
						<option each="{ location in state.locations }" if="{ location.parent_id == 0 }" value="{ location.id }" selected="{ state.levels[0].id == location.id }">{ location.title }</option>
					</select>
				</div>
				<div class="column">
					<select class="form-control" data-ref="level1" data-level="1" onchange="{ location_change }" disabled="{ state.levels[0].id == 0 || !state.levels[0].has_children }">
						<option value="0">επιλέξτε ευρύτερη περιοχή</option>
						<option each="{ location in state.locations }" if="{ location.parent_id == state.levels[0].id }" value="{ location.id }" selected="{ state.levels[1].id == location.id ? 'selected' : '' }">{ location.title }</option>
					</select>
				</div>
				<div class="column">
					<select class="form-control" data-ref="level1" data-level="2" onchange="{ location_change }" disabled="{ state.levels[1].id == 0 || !state.levels[1].has_children }">
						<option value="0">επιλέξτε περιοχή</option>
						<option each="{ location in state.locations }" if="{ location.parent_id == state.levels[1].id }" value="{ location.id }" selected="{ state.levels[2].id == location.id ? 'selected' : '' }">{ location.title }</option>
					</select>
				</div>
			</div>
			<div class="select-button">
				<button class="btn btn-primary btn-block" title="αναζήτηση με πληκτρολόγηση" onclick="{ toggle_search_mode }"><i class="fa fa-search"></i></button>
			</div>
		</div>

		<div class="select { state.search_mode ? 'expanded' : '' } { state.search_results.length ? 'expand-search' : '' }">
			<div class="select-body">

				<input type="text" data-ref="location" class="form-control search-input" placeholder="πληκτρολογήστε την περιοχή που ζητάτε" onkeyup="{ input_change }">
				<loader-icon class="input-loader" if="{ state.searching }"></loader-icon>

				<div class="dropdown" if="{ state.search_results.length }">
					<ul>
						<li each="{ location in state.search_results }">
							<a href="#" onclick="{ search_result_select }">{ location.path }</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="select-button">
				<button class="btn btn-primary btn-block" title="επιλογή από λίστα" onclick="{ toggle_search_mode }"><i class="fa fa-list"></i></button>
			</div>
		</div>

		<loader-icon class="control-loader" if="{ state.loading }"></loader-icon>
	</div>

	<script>
	/*
		Methods:
		initialize( locations array ) :: initialize the control with the locations in array
		set_value( location id ) :: sets the location to select
		get_value() :: returns the selected location id

		Events:
		onchangehandler( location object ) :: triggers when a location is selected

		Opts:
		vertical :: "true" - location select inputs displayed in vertical order
		allownone:: "true" - user can select location with id 0 (no location option)
	*/
		this.state = {
			allownone: this.opts.allownone == 'true',

			selected: 0,
			search_results: [],
			search_mode: false,
			
			locations: [],

			levels: [ {	title: '', id: 0, has_children: false }, { title: '', id: 0, has_children: false }, { title: '', id: 0, has_children: false } ],

			loading: false,
			searching: false,
		}

		this.timer = null;


		this.set_value = id => {
			this.state.selected = id;
			
			if (!this.state.locations.length && !this.state.loading) {
				this.load_locations();
			} else {
				this.set_selected_locations();
			}
		}


		this.get_value = () => {
			return this.state.selected;
		}


		// Sets the select inputs with the selected locations specified by state.selected
		this.set_selected_locations = trigget_events => {

			this.init_levels(0);
			
			// find location in list
			var location = this.location_find(this.state.selected);
			var selected_location = this.location_find(this.state.selected);
			
			while (location) {
				this.state.levels[location.level].id = location.id;
				this.state.levels[location.level].title = location.title;
				this.state.levels[location.level].has_children = location.has_children;

				location = this.location_find(location.parent_id);
			}		

			this.update();

			if (typeof trigget_events !== 'undefined') {
				if (this.opts.onchangehandler) {
					this.opts.onchangehandler(selected_location);
				}
			}
		}


		// Initialize the "levels" array in state
		this.init_levels = level => {
			for (var i = level; i < 3; i++) {
				this.state.levels[i].id = 0;
				this.state.levels[i].title = '';
				this.state.levels[i].has_children = false;
			}
		}


		// returns the location with "id"
		this.location_find = id => {
			return this.state.locations.find( item => item.id == id ) || null;
		}


		this.location_change = event => {
			// get location level
			var level = parseInt($(event.target).attr("data-level"));

			//unselect all locations from sub levels
			this.init_levels(level);

			var location = this.location_find(event.target.value);
			if (location) {
				// select current location
				this.state.levels[level].id = location.id;
				this.state.levels[level].title = location.title;
				this.state.levels[level].has_children = location.has_children;
				this.state.selected = location.id;
			} else {
				// find previus level location
				if (level == 2) {
					location = this.location_find(this.refs.level1.value);
					this.state.selected = location.id;
				} else if (level == 1) {
					location = this.location_find(this.refs.level0.value);
					this.state.selected = location.id;
				}
			}
			if (!location) location = null;
			if (this.opts.onchangehandler) {
				this.opts.onchangehandler(location);
			}
		}


		/* Search handlers */

		// toggle between type and select
		this.toggle_search_mode = event => {
			event.preventDefault();
			this.state.search_mode = !this.state.search_mode;
		}


		this.input_change = event => {
			if (this.timer) {
				this.state.searching = false;
				clearTimeout(this.timer);
			}

			var term = this.refs.location.value.trim();
			if (term.length > 2) {
				this.state.searching = true;
			
				var tag = this;
				this.timer = setTimeout(function() {
					clearTimeout(tag.timer);
					tag.search_location(latin2greek(term));
				}, 1000);
			}
		}


		this.search_location = term => {
			this.state.searching = true;
			this.update();

			var tag = this;
			request(
				'location_search',
				{
					'term': term
				},
				function(result) {
					tag.state.search_results = result.locations;
					tag.state.searching = false;
					tag.update();
				},
				true
			);
		}

		this.search_result_select = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			this.state.search_results = [];
			//this.refs.location.value = event.item.location.title;
			this.state.selected = event.item.location.id;
			//this.state.search_mode = false;
			this.set_selected_locations(true);

			this.state.search_mode = false;
		}


		this.load_locations = () => {
			var tag = this;
			api_request(
				'locations',
				{},
				function(result) {
					tag.state.locations = result.data;

					tag.set_selected_locations();

					tag.update();
				}, null, this.toggle_loader
			);
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}
	</script>
</control-location-select>